#include <math.h>

const int ledPotPin = A0;
const int motorPotPin = A1;
const int redLedPin = 9;
const int greenLedPin = 10;
const int blueLedPin = 11;
const int motorPin = 6;

int ledPotVal;
int motorPotVal;
unsigned long previousMillis = 0;
unsigned long currentMillis = 0;
int currentTime = 0;
int increment = 0;
int redValue;
int greenValue;
int blueValue;
int redBrightness = 0;
int greenBrightness = 0;
int blueBrightness = 0;
int motorPower = 0;

void setup() {

  Serial.begin(9600);
  pinMode(redLedPin,OUTPUT);
  pinMode(greenLedPin,OUTPUT);
  pinMode(blueLedPin,OUTPUT);
  pinMode(motorPin, OUTPUT);

}

void loop() {
  ledPotVal = analogRead(ledPotPin);
  motorPotVal = analogRead(motorPotPin);
  float ledBrightness = ledPotVal/1024.0;

//  Serial.print("currentMillis: ");
//  Serial.print(currentMillis);
//  Serial.print("\t");
//  Serial.print("currentTime: ");
//  Serial.print(currentTime);
//  Serial.print("\t");
//  Serial.print("increment: ");
//  Serial.print(increment);
//  Serial.print("\t");
//  Serial.print("R: ");
//  Serial.print(redValue); 
//  Serial.print("\t");
//  Serial.print("G: ");
//  Serial.print(greenValue);
//  Serial.print("\t");
//  Serial.print("B: ");
//  Serial.print(blueValue);
//  Serial.print("\t");
  Serial.print("ledPotVal: ");
  Serial.print(ledPotVal);
  Serial.print("\t");
  Serial.print("brightness: ");
  Serial.print(ledBrightness);
  Serial.print("\t");
  Serial.print(redBrightness);
  Serial.print("\t");
  Serial.print(greenBrightness);
  Serial.print("\t");
  Serial.print(blueBrightness);
  Serial.print("\t");
  Serial.print("motorPotVal: ");
  Serial.print(motorPotVal);
  Serial.print("\t");
  Serial.print("motorPower: ");
  Serial.println(motorPower);

currentMillis = millis();
  if ((unsigned long)(currentMillis - previousMillis) >= 1) {
    previousMillis = currentMillis;
    increment++;
    if (increment > 255){
      currentTime++;
      increment = 0;
    }
    if (currentTime  == 0){
     redValue++;
     greenValue = 0;
     blueValue--;
    }
    else if (currentTime == 1){
      redValue--;
      greenValue++;
      blueValue = 0;
    }
    else if (currentTime == 2){
     redValue = 0;
     greenValue--;
     blueValue++;
    }
    else{
      currentTime = 0;
    }
  }

  //Catch overshoots
  if(redValue < 0) {
  redValue = 0;
  }
  if(greenValue < 0) {
  greenValue = 0;
  }
  if(blueValue < 0) {
  blueValue = 0;
  }
  if(redValue > 255) {
  redValue = 255;
  }
  if(greenValue  >255) {
  greenValue = 255;
  }
  if(blueValue >255) {
  blueValue = 255;
  }

  redBrightness = redValue * ledBrightness;
  greenBrightness = greenValue * ledBrightness;
  blueBrightness = blueValue * ledBrightness;

  motorPower = motorPotVal / 4;
 //motorPower = 0;
  
analogWrite(redLedPin, redBrightness);
analogWrite(greenLedPin, greenBrightness);
analogWrite(blueLedPin, blueBrightness);

analogWrite(motorPin, motorPower);
}
